<?php
if (!$state['logged_on'])
	die("Not logged in.\n");

$query = 0;
$str = "Add";
$c_id = "";
$c_name = "";
$c_parent = "";
$mode = "add";
$category = "";

if (strlen($state['input']['mode'])) {
	if ($state['input']['mode'] == "del" && strlen($state['input']['category'])) {
		$mode = "del";
		$str = "Delete";
		$query = 1;
		$category = $state['input']['category'];
	}
	if ($state['input']['mode'] == "edit" && strlen($state['input']['category'])) {
		$mode = "edit";
		$str = "Edit";
		$query = 1;
		$category = $state['input']['category'];
	}
}
    
if ($query) {
	$result = $database->Query(
		"SELECT id, name, parent FROM categories WHERE id = ? AND user = ?",
        array($category, $state['user_id']));

	if ($row = $result->FetchRow()) {
		$c_id = $row["id"];
		$c_name = $row["name"];
		$c_parent = $row["parent"];
	}
}


if ($mode == "del") {
	echo "<p class=\"warning\">Warning: All links in this category will be removed ".
		"as well.</p>\n";
}
?>

<form class="cat_form" method="post" action="?show=main">
<fieldset>
<legend><?=$str?> category</legend>
<input type="hidden" name="action" value="submit<?=$mode?>category"/>
<input type="hidden" name="c_id" value="<?=$c_id?>"/>
<table border="0" cellspacing="0">

<!-- READONLY als DELETE -->
<tr><td><b>Name</b></td><td><input type="text" size="40" name="c_name" value="<?=$c_name?>"/></td></tr>
<tr><td><b>Parent</b></td><td>

<!-- DISABLED als DELETE -->
<select name="c_parent">
<option value="1">No Parent</option>
<?
$result = $database->Query("SELECT id,name FROM categories WHERE id != ? AND id != 1 AND user = ?",
                        array($c_id, $state['user_id']));

foreach ($result as $k => $row)
{
	echo "<option value=\"".$row["id"]."\"".
		((strlen($c_parent)&&$c_parent==$row["id"])?" selected=\"selected\"":"").">".$row["name"]."</option>\n";
}
?>
</select>
</td></tr>
</table>
<input type="submit" value="<?=$str?>"/>
</fieldset>
</form>
