<?php

function printHeader($id, $str) {
	global $state, $show_id, $HeaderBackground;
	
	$text = "";
	
	$text .= "<tr class=\"header\">\n";
	$text .= "  <td><b>$str</b></td>\n";
	if ($state['logged_on'] && $state['user_id'] == $show_id) {
		$text .= "  <td align=\"right\">";
		$text .= createLink(
			"<img src=\"startpage_images/add.gif\" class=\"add\" alt=\"add\"/>",
			"?show=link&mode=add&category=$id");
		$text .= createLink(
            "<img src=\"startpage_images/info.gif\" class=\"edit_cat\" alt=\"edit\"/>",
			"?show=category&mode=edit&category=$id");
		$text .= createLink(
			"<img src=\"startpage_images/trash.gif\" class=\"del_cat\" alt=\"del\"/>",
			"?show=category&mode=del&category=$id");
		$text .= "&nbsp;</td>\n";
	} else {
		$text .= "  <td>&nbsp;</td>\n";
	}
	$text .= "</tr>\n";

	return $text;
}

function printLink($id, $link, $linktext, $category) {
	global $state, $show_id, $LinkBackground;

	$text = "";
	
	$text .= "<tr class=\"link\">\n";
	$text .= "<td>";
	$text .= "<a href=\"count.php?id=$id\">$linktext</a>";
	$text .= "</td>\n";
	if ($state['logged_on'] && $state['user_id'] == $show_id) {
		$text .= "  <td align=\"right\">";
		$text .= createLink(
            "<img src=\"startpage_images/info.gif\" class=\"edit_link\" alt=\"edit\"/>",
            "?show=link&mode=edit&link=$id");
		$text .= createLink(
            "<img src=\"startpage_images/trash.gif\" class=\"del_link\" alt=\"del\"/>",
            "?show=link&mode=del&link=$id");
		$text .= "</td>\n";
	} else {
		$text .= "  <td>&nbsp;</td>\n";
	}
	$text .= "</tr>\n";

	return $text;
}

function print_category($category, $column) {
	global $database, $debug, $CombineCategoryChilds, $coltext, $colcount, $show_id;

	$text = "";
	
	if (!$debug) {
		$text .= printHeader($category["id"],$category["name"]);
	} else {
		$text .= printHeader($category["id"],
			$category["name"]."(".$category["count"].")");
	}
	$resultLinks = $database->Query(
			"SELECT id, name, link, count FROM links WHERE ".
			"category = ? AND user = ? ORDER BY count DESC, id",
            array($category['id'], $show_id));

	foreach ($resultLinks as $k => $rowlink)
    {
		if (!$debug) {
			$text .= printLink($rowlink["id"], $rowlink["link"],
					$rowlink["name"], $category["id"]);
		} else {
			$text .= printLink($rowlink["id"], $rowlink["link"],
					$rowlink["name"]."(".$rowlink["count"].")",
					$category["id"]);
		}
	}
	$coltext[$column] .= $text;
	$colcount[$column] += 1 + $resultLinks->RecordCount();

	if ($CombineCategoryChilds) {
		$resultChildCategories = $database->Query(
    			"SELECT id, name, count FROM categories WHERE ".
	    		"parent = ? AND user = ? ORDER BY count DESC",
                array($category["id"], $show_id));
		if ($resultChildCategories->RecordCount()) {
			foreach ($resultChildCategories as $k => $row)
				print_category($row, $column);
		}
	}
}

$coltext = array();
$colcount = array();

if (!isset($numcol))
	$numcol = $DefaultColumnCount;

for ($i=0; $i < $numcol; $i++) {
	$coltext[$i] = "";
	$colcount[$i] = 0;
}

if ($CombineCategoryChilds) {
	$resultParentCategories = $database->Query(
		"SELECT id, name, count FROM categories WHERE id != '1' AND ".
		"parent = 1 AND user = ? ORDER BY count DESC",
        $show_id);
} else {
	$resultParentCategories = $database->Query(
		"SELECT id, name, count FROM categories WHERE id != '1' ".
		"AND user = ? ORDER BY count DESC",
        $show_id);
}

if ($resultParentCategories->RecordCount()) {
    foreach ($resultParentCategories as $k => $row)
    {
		$lowest = $colcount[0];
		$lowest_id = 0;

		for ($i = 1; $i < $numcol; $i++) {
			if ($colcount[$i] < $lowest) {
				$lowest = $colcount[$i];
				$lowest_id = $i;
			}
		}

		print_category($row, $lowest_id);
		$coltext[$lowest_id] .= "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
		$colcount[$lowest_id] += 1;
	}
}

if (strlen($HTMLHeading))
	echo "<center><h1>$HTMLHeading</h1></center>\n";

echo "<table border=\"0\" cellspacing=\"0\">\n";
echo "<tr class=\"full\">\n";

foreach ($coltext as $column) {
	echo "<td class=\"column\">";
	echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\">\n";
	echo $column;
	echo "</table></td>\n";
	echo "<td>&nbsp;&nbsp;&nbsp;</td>\n";
}

echo "</tr>\n";
echo "</table>\n";
echo "<div>\n";
if ($state['logged_on']) {
	if ($state['user_id'] == $show_id) {
		echo createLink("Add a new category",
			"?show=category&mode=add");
		echo "<br/>\n";
	}
	echo createLink("Log off","?action=submitlogoff");
	if ($_SESSION['admin'] == 1) {
		echo createLink("User Management", "?show=users&mode=list");
	}
} else
	echo createLink("Log in","?show=login");
echo "</div>\n";
?>
